#include "setup_functions.h"


template <class indep_var> indep_var bc4(const indep_var * x, int n){
  int  i, j;
  indep_var fad=1;
  indep_var fi=0;
/*---------------------------------------------------------------------------------*/
/*the one dimensional output variable is fad, in other words, f: R^n -> R. f(x) = fad */
/*  You may use all basic functions, for a complete list consult the ADOL-C manuel */

//Brachistochrone Problem NAME: bc4, princeton noncute
//fad =1;
double * param;
param = new double [n];
indep_var * dydx;
dydx = new indep_var [n];

for(i=0;i<n;i++){
     param[i] = pow(double(i)/double(n),4);
}

for(i=1;i<n;i++)
   dydx[i] = (x[i] - x[i-1])/(param[i] - param[i-1]);

for(i=1;i<n;i++){
    fad = fad +  sqrt( (1+pow(dydx[i],2))/x[i-1] )*(param[i]-param[i-1]);
}

    return(fad);
}

template double bc4<double>(const double  *x, int n);
template adouble bc4<adouble>(const adouble  *x, int n);
ObjectiveFunction * setup_bc4(int dimension){
double * x_initial = new double [dimension];
    for(int i=0; i<dimension ; i++) x_initial[i] =double(i)/double(dimension);
    x_initial[0] =  1.0E-10;
    x_initial[dimension] = 1;
  ObjectiveFunction * OFbc4 = new ObjectiveFunction(dimension, x_initial, bc4<double>, bc4<adouble>, "bc4");
 return(OFbc4); }
