#include "setup_functions.h"


template <class indep_var>  indep_var ncvxqp3(const indep_var * x, int n){
  int  i, j;
  indep_var fad=1;
  indep_var fi=0;
/*---------------------------------------------------------------------------------*/
/*the one dimensional output variable is fad, in other words, f: R^n -> R. f(x) = fad */
/*  You may use all basic functions, for a complete list consult the ADOL-C manuel */

//name: ncvxqp3
// AMPL Model by Hande Y. Benson
// Copyright (C) 2001 Princeton University
int M =n/2;
int nPLUS = 3*n/4;

//var x{1..n} >= 0.1, <= 10.0, := 0.5;
//TERRIBLE numeric stability
//minimize f:
	for(i=1; i<nPLUS; i++)
	    fad =fad+ pow((x[i]+x[(2*i-1) % n ] +x[(3*i-1) % n ]),2*i/2);
	for(i=nPLUS+1; i<n; i++)
	    fad = fad - pow((x[i]+x[(2*i-1) % n] +x[(3*i-1) % n]),2*i/2) ;
    return(fad);
}

template double ncvxqp3<double>(const double  *x, int n);
template adouble ncvxqp3<adouble>(const adouble  *x, int n);
ObjectiveFunction * setup_ncvxqp3(int dimension){
double * x_initial = new double [dimension];
    for(int i=0; i<dimension ; i++) x_initial[i] =0.5;
  ObjectiveFunction * OFchainwood = new ObjectiveFunction(dimension, x_initial, ncvxqp3<double>, ncvxqp3<adouble>, "ncvxqp3");
 return(OFchainwood); }
